<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class install extends core
{
    /*инициализация объектов для работы данного класса*/
    function install($value)
    {
        $this->core();
        
        $this->modul = $value['install'];
        $this->tree  = $value['tree'];
        $this->type  = $value['type'];
    }

    function install_tree()
    {
        switch($this->modul){
            case 'content':
                $this->get_info_content();
                break;
            case 'widget':
                $this->get_info_widget();
                break;
            case 'catalog':
                $this->get_info_catalog();
                break;
            case 'parameter':
                $this->get_info_parameter();
                break;
            default:
                die('installation error, command not found');
                break;
        }
    }

    /*
     *
     *  МЕТОД УСТАНОВКИ МОДУЛЯ CONTENT
     *
     */

    function get_info_content()
    {
        // проверка сущ. модулей и определение их ID
        if (!$this->get_modul_id('admin.content'))
            die('installation error, module admin.content not found');

        if (!$this->get_modul_id('admin.fields'))
            die('installation error, module admin.fields not found');            

        if (!$this->get_modul_id('admin.content.nesting'))
            die('installation error, module admin.content.nesting not found');

        $dir = __DIR__.'/cfg/admin/content.xml';
        $xml = simplexml_load_file($dir);
        
        $this->install_modul($xml, $this->tree);
        
        die('installation is complete');
    }
    
    /*
     *
     *  МЕТОД УСТАНОВКИ МОДУЛЯ WIDGET
     *
     */

    function get_info_widget()
    {
        // проверка сущ. модулей и определение их ID
        if (!$this->get_modul_id('admin.widget'))
            die('installation error, module admin.widget not found');

        if (!$this->get_modul_id('admin.fields'))
            die('installation error, module admin.fields not found');            

        if (!$this->get_modul_id('admin.widget.nesting'))
            die('installation error, module admin.widget.nesting not found');
        
        $dir = __DIR__.'/cfg/admin/widget.xml';
        $xml = simplexml_load_file($dir);
        
        $this->install_modul($xml, $this->tree);
        
        die('installation is complete');
    }

    /*
     *
     *  МЕТОД УСТАНОВКИ МОДУЛЯ CATALOG
     *
     */

    function get_info_catalog()
    {
        // проверка сущ. модулей и определение их ID
        if (!$this->get_modul_id('admin.catalog'))
            die('installation error, module admin.catalog not found');
            
        if (!$this->get_modul_id('admin.fields'))
            die('installation error, module admin.fields not found'); 
        
        
        $dir = __DIR__.'/cfg/admin/catalog.xml';
        $xml = simplexml_load_file($dir);
        
        $this->install_modul($xml, $this->tree);
        
        die('installation is complete');
    }

    /*
     *
     *  МЕТОД УСТАНОВКИ МОДУЛЯ PARAMETER
     *
     */

    public function get_info_parameter()
    {
        // проверка сущ. модулей и определение их ID
        if (!$this->get_modul_id('admin.parameter'))
            die('installation error, module admin.parameter not found');
            
        if (!$this->get_modul_id('admin.parameter.catalog'))
            die('installation error, module admin.parameter.catalog not found');
            
        if (!$this->get_modul_id('admin.parameter.content'))
            die('installation error, module admin.parameter.content not found');             
        
        if (!$this->get_modul_id('admin.parameter.param'))
            die('installation error, module admin.parameter.param not found');        
        
        if (!$this->get_modul_id('admin.parameter.param.value'))
            die('installation error, module admin.parameter.param.value not found'); 
        
        $dir = __DIR__.'/cfg/admin/parameter.xml';
        $xml = simplexml_load_file($dir);
        
        $this->install_modul($xml, $this->tree);
        
        die('installation is complete');
    }

    /*
     *
     *  МЕТОДЫ УСТАНОВКИ УЗЛОВ И МОДУЛЕЙ
     *
     */

    function install_modul($xml, $tree)
    {
        foreach ($xml as $node) {
            
            // получаем параметры узла
            $attr = get_object_vars($node->attributes());
            $attr = $attr['@attributes'];
            
            if (!isset($attr['start'])) {
                // собираем инфу о узле и записываем ее
                
                $fields = array(
                    'map_alias'     => $attr['name'],
                    'map_name'      => (!isset($attr['caption'])) ? '' : $attr['caption'],
                    'map_parent'    => $tree,
                    'map_tree_type' => $attr['type']
                );
                
                if (!$this->add_tree($fields))
                    die('installation error node');
            }
            else
                $fields['map_id'] = $tree;
            
            // получаем модули узла
            if (isset($node->module))
                foreach ($node->module as $module) {
                    
                    $module = get_object_vars($module->attributes());
                    $module = $module['@attributes'];

                    if (preg_match("/%type%/si", $module['value']))
                        $module['value'] = preg_replace("/%type%/si", $this->type, $module['value']);
                    
                    $massiv = array(
                        'map_id'        => $fields['map_id'],
                        'modul_id'      => $this->get_modul_id($module['name']),
                        'modul_val'     => $module['value'],
                        'parent'        => $module['parent']
                    );
                    
                    if (!$this->add_modules($massiv))
                        die('error installing the module');
                }
            
            if (isset($node->node))
                $this->install_modul($node->node, $fields['map_id']);
        }        
    }

    // поиск ID модуля по имени
    function get_modul_id($modul_name)
    {
        $sql = "SELECT * FROM rs_modules WHERE modul_name='".$modul_name."'";
        
        if (!$modul = $this->db->accept_select($sql))
            return FALSE;
        
        return $modul[0]['modul_id'];
    }
    
    // доабвление узла
    function add_tree(&$fields)
    {
        if (!$fields['map_alias'] = $this->sysDB->check_take_alias($fields['map_alias'], $fields['map_parent']))
            return FALSE;
            
        $map_array = array(
            'map_alias'     => $fields['map_alias'],
            'map_name'      => $fields['map_name'],
            'map_parent'    => $fields['map_parent'],
            'map_tree_type' => $fields['map_tree_type']
        );
        
        if (!$fields['map_id']    = $this->sysDB->insert_map($map_array, 1))
            return FALSE;
            
        return TRUE;
    }
    
    // добавления модуля в узел
    function add_modules($massiv)
    {
        /*
         * Задача заполнить строчку в таблице RS_CONNECT_MODULES 
         * 1. По map_id определяем map_modules (в табл rs_map) (определили значение поля MAP_MODULES)
         * 2. Вытаскиваем все модули по map_modules из таблицы rs_connect_modules
         * считаем сколько их и определяем инфу для поля CONNECT_POSITION
         * значения MODUL_ID, CONNECT_VALUE, CONNECT_BLOCK присылаются из формы 
         * CONNECT_PARENT по умолчанию 0
         */

        if (!$map_modules = $this->get_map_modules($massiv['map_id']))
            return FALSE;
        
        $connect_position = $this->get_position($map_modules, 1) + 1;
        
        $what = array(
            'modul_id'          => $massiv['modul_id'],
            'map_modules'       => $map_modules,
            'connect_value'     => $massiv['modul_val'],
            'connect_block'     => 1,
            'connect_parent'    => $massiv['parent'],
            'connect_position'  => $connect_position
        );

        if (!$this->db->accept_insert($what, 'rs_connect_modules'))
            return FALSE;
            
        return TRUE;
    }
    
    // определение позиции модуля в узле
    function get_position($map_modules, $block)
    {
        $sql = "SELECT COUNT(*) FROM rs_connect_modules WHERE map_modules='".$map_modules."' AND connect_block='".$block."'";
        
        if (!$position = $this->db->accept_count_select($sql))
            return FALSE;
        
        return $position;
    }

    // Находим значение поля map_modules в таблице rs_map
    function get_map_modules($map_id)
    {
        $sql = "SELECT map_modules FROM rs_map WHERE map_id='".$map_id."'";
        
        if (!$map_modules = $this->db->accept_select($sql))
            return FALSE;
        
        return $map_modules[0]['map_modules'];
    }
}
?>