<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class paramContent extends core
{
    /*инициализация объектов для работы данного класса*/
    public function paramContent()
    {
        $this->core();
        
        $this->value = array();
    }
    
    /* CASE : ADD */
    
    public function addValue($paramContent, $content_id)
    {
        if (!empty($paramContent))
            foreach ($paramContent as $param_id => $param)
                if (is_array($param))
                    foreach ($param as $key_param => $value_param)
                        $this->insert_value($content_id, $param_id, $value_param);
                else
                    $this->insert_value($content_id, $param_id, $param);
                
        return TRUE;
    }
    
    private function insert_value($content_id, $param_id, $value_id)
    {
        if ($value_id === 0)
            return FALSE;
        
        $what = array(
            'content_id'        => $content_id,
            'param_id'          => $param_id,
            'value_id'          => $value_id
        );

        $this->db->accept_insert($what, 'rs_param_content');
        
        return TRUE;
    }

    /* CASE : EDIT */
    
    public function editValue($paramContent, $content_id)
    {
        // удаляем все значения
        $this->db->accept_delete("DELETE FROM rs_param_content WHERE content_id='".$content_id."'");
        
        // записываем новые
        $this->addValue($paramContent, $content_id);
                
        return TRUE;
    }

    /* DELETE */
    
    public function deleteContent($content_id)
    {
        // удаляем все значения
        $this->db->accept_delete("DELETE FROM rs_param_content WHERE content_id='".$content_id."'");
    }
    
    /* РАЗНОЕ */
    
    public function getValue($content_id)
    {
        $sql = ""
            ."SELECT"
                ." content.content_id         AS content_id,"
                ." content.param_id           AS param_id,"
                ." content.value_id           AS value_id"
            ." FROM"
                ." rs_param_content           content"
            ." WHERE"
                ."     content.content_id     = '".$content_id."'"
        ;
        
        if(!$values = $this->db->accept_select($sql))
            return FALSE;
        
        foreach ($values as $key => $value)
            $this->value[$value['value_id']] = $value['value_id'];
            
        return TRUE;
    }
    
    public function getListParam($catalog_id)
    {
        $paramList = array();
        
        // вытаскиваем группы
        $sql = ""
            ."SELECT"
                ." gr.group_id                AS group_id,"
                ." gr.group_name              AS group_name"
            ." FROM"
                ." rs_param_catalog           catalog,"
                ." rs_param_group             gr"
            ." WHERE"
                ."     catalog.catalog_id     = '".$catalog_id."'"
                ." AND gr.group_parent        = catalog.group_id"
            ." ORDER BY gr.group_position"
        ;

        if(!$groups = $this->db->accept_select($sql))
            $this->tools->not_found();
        
        foreach ($groups as $key_group => $group) {
            
            $paramList[$group['group_id']] = array(
                'group_name'    => $group['group_name'],
                'group_param'   => array()
            );
            
            // вытаскиваем параметры
            $sql = ""
                ."SELECT"
                    ." param.param_id             AS param_id,"
                    ." param.param_name           AS param_name,"
                    ." param.param_type           AS param_type,"
                    ." param.group_id             AS group_id"
                ." FROM"
                    ." rs_param                   param"
                ." WHERE"
                    ." param.group_id         = '".$group['group_id']."'"
                ." ORDER BY param.param_position"
            ;

            if(!$params = $this->db->accept_select($sql))
                $this->tools->not_found();
            
            foreach ($params as $key_param => $param) {
                
                $paramList[$group['group_id']]['param'][$param['param_id']] = array(
                    'param_id'        => $param['param_id'],
                    'param_name'      => $param['param_name'],
                    'param_type'      => $param['param_type'],
                    'group_id'        => $param['group_id'],
                    'param_value'     => array()
                );
                
                // вытаскиваем значения
                $sql = ""
                    ."SELECT"
                        ." value.value_id             AS value_id,"
                        ." value.value_name           AS value_name,"
                        ." value.param_id             AS param_id"
                    ." FROM"
                        ." rs_param_value             value"
                    ." WHERE"
                        ." value.param_id             = '".$param['param_id']."'"
                    ." ORDER BY value.value_position"
                ;
                
                if(!$values = $this->db->accept_select($sql))
                    $this->tools->not_found();
                    
                foreach ($values as $key_value => $value)
                    $paramList[$group['group_id']]['param'][$param['param_id']]['param_value'][$value['value_id']] = array(
                        'value_id'        => $value['value_id'],
                        'value_name'      => $value['value_name'],
                        'param_id'        => $value['param_id'],
                        'current'         => (isset($this->value[$value['value_id']])) ? 'true' : 'false'
                    );
            }
        }
        
        return $paramList;
    }
}
?>